;********************************************************
;*              DX9 subsystem extensions                *
;********************************************************

Procedure RGB2BGR(RGB)
ProcedureReturn Blue(RGB)+Green(RGB)<<8+Red(RGB)<<16
EndProcedure
  
Structure MyD3DTLVERTEX
  x.f
  y.f
  z.f
  rhw.f
  Color.l
  tu.f
  tv.f
EndStructure 
  
Structure PB_DX9Sprite3D
  TexRes.l                    ; TexRes
  Vertice.MyD3DTLVERTEX[4]    ; The 4 vertices for the rectangle sprite
  TmpVertice.MyD3DTLVERTEX[4] ; The 4 vertices for the rectangle sprite
  Width.l			                ; width set with ZoomSprite3D()
  Height.l			              ; height set with ZoomSprite3D()
  RealWidth.l
  RealHeight.l
  Angle.f
  Transformed.l
EndStructure
  
Structure MyTexCoord
  tu.f
  tv.f
EndStructure


Structure PB_DX9Sprite
  TexRes.l       ; TexRes
  Width.l        ; Current width of the sprite (could change if ClipSprite() is used)
  Height.l       ; Current height of the sprite (could change if ClipSprite() is used)
  Depth.l        ; depth of shade of the file. (in bits)  
  Mode.l         ; Sprite mode, as described in LoadSprite()
  FileName.l     ; Pointer on the filename, if any
  RealWidth.l    ; Original width of the sprite when it was loaded
  RealHeight.l   ; Original height of the sprite when it was loaded   
  ClipX.l        ; X offset if ClipSprite()
  ClipY.l        ; Y offset if ClipSprite()
  t.MyTexCoord[4]
  TexRes2.l
  fU.f
  fV.f
EndStructure
  
  
Procedure DX9S_ClipSprite3D(Sprite3D.l,ClipX.l,ClipY.l,ClipWidth.l,ClipHeight.l)
  *ptr.PB_DX9Sprite3D=IsSprite3D(Sprite3D)
  If *ptr=0:ProcedureReturn #False:EndIf
  
  If ClipX<0:ClipX=0:EndIf
  If ClipY<0:ClipY=0:EndIf
  
  If ClipWidth<0:ClipWidth=0:EndIf
  If ClipHeight<0:ClipHeight=0:EndIf
  
  If ClipX>*ptr\RealWidth:ClipX=*ptr\RealWidth:EndIf
  If ClipY>*ptr\RealHeight:ClipY=*ptr\RealHeight:EndIf
  
  If ClipX+ClipWidth>*ptr\RealWidth:ClipWidth=*ptr\RealWidth-ClipX:EndIf
  If ClipY+ClipHeight>*ptr\RealHeight:ClipHeight=*ptr\RealHeight-ClipY:EndIf
  
  *ptr\Vertice[0]\tu=ClipX/*ptr\RealWidth
  *ptr\Vertice[0]\tv=ClipY/*ptr\RealHeight 
  
  *ptr\Vertice[1]\tu=(ClipX+ClipWidth)/*ptr\RealWidth 
  *ptr\Vertice[1]\tv=ClipY/*ptr\RealHeight
  
  *ptr\Vertice[2]\tu=ClipX/*ptr\RealWidth 
  *ptr\Vertice[2]\tv=(ClipY+ClipHeight)/*ptr\RealHeight 
  
  *ptr\Vertice[3]\tu=(ClipX+ClipWidth)/*ptr\RealWidth 
  *ptr\Vertice[3]\tv=(ClipY+ClipHeight)/*ptr\RealHeight 
  
  ProcedureReturn #True
EndProcedure
  
  

Procedure DX9S_SetSprite3DColor(Sprite3D.l,Color1.l,Color2.l,Color3.l,Color4.l)
  *ptr.PB_DX9Sprite3D=IsSprite3D(Sprite3D)
  If *ptr=0:ProcedureReturn #False:EndIf
  
  *ptr\Vertice[0]\Color=RGB2BGR(Color1)
  *ptr\Vertice[1]\Color=RGB2BGR(Color2)
  *ptr\Vertice[2]\Color=RGB2BGR(Color3)
  *ptr\Vertice[3]\Color=RGB2BGR(Color4)
  
  ProcedureReturn #True
EndProcedure

Procedure DX9S_GetD3DDevice9()
  !EXTRN _PB_DX9S_Direct3D_Device
  !MOV Eax,[_PB_DX9S_Direct3D_Device]
  ProcedureReturn 
EndProcedure
  
Procedure DX9S_GetD3D9()
  !EXTRN _PB_DX9S_D3DBase
  !MOV Eax,[_PB_DX9S_D3DBase]
  ProcedureReturn 
EndProcedure

Procedure DX9S_GetScreenDepth()
  !EXTRN _PB_DX9S_Screen_Depth
  !MOV Eax,[_PB_DX9S_Screen_Depth]
  ProcedureReturn 
EndProcedure

Procedure DX9S_GetScreenWidth()
  !EXTRN _PB_DX9S_Screen_Width
  !MOV Eax,[_PB_DX9S_Screen_Width]
  ProcedureReturn 
EndProcedure

Procedure DX9S_GetScreenHeight()
  !EXTRN _PB_DX9S_Screen_Height
  !MOV Eax,[_PB_DX9S_Screen_Height]
  ProcedureReturn 
EndProcedure

Procedure DX9S_GetScreenRealWidth()
  !EXTRN _PB_DX9S_Screen_RealWidth
  !MOV Eax,[_PB_DX9S_Screen_RealWidth]
  ProcedureReturn 
EndProcedure

Procedure DX9S_GetScreenRealHeight()
  !EXTRN _PB_DX9S_Screen_RealHeight
  !MOV Eax,[_PB_DX9S_Screen_RealHeight]
  ProcedureReturn 
EndProcedure
  
Procedure DX9S_IsWindowed()
  !EXTRN _PB_DX9S_Screen_Windowed
  !MOV Eax,[_PB_DX9S_Screen_Windowed]
  ProcedureReturn 
EndProcedure
    
Procedure DX9S_ChangeWindowedScreen(Autostretch.l,XOffset.l,YOffset.l,RightBorder.l,BottomBorder.l)
  !EXTRN _PB_DX9S_Screen_AutoStretch
  !EXTRN _PB_DX9S_Screen_WindowedBottomBorder
  !EXTRN _PB_DX9S_Screen_WindowedRightBorder
  !EXTRN _PB_DX9S_Screen_WindowedXOffset
  !EXTRN _PB_DX9S_Screen_WindowedYOffset 
  !MOV Eax,[Esp+4]
  !MOV [_PB_DX9S_Screen_AutoStretch],Eax
  !MOV Eax,[Esp+8]
  !MOV [_PB_DX9S_Screen_WindowedXOffset],Eax
  !MOV Eax,[Esp+12]
  !MOV [_PB_DX9S_Screen_WindowedYOffset],Eax
  !MOV Eax,[Esp+16]
  !MOV [_PB_DX9S_Screen_WindowedRightBorder],Eax
  !MOV Eax,[Esp+16]
  !MOV [_PB_DX9S_Screen_WindowedBottomBorder],Eax
  ProcedureReturn 
EndProcedure  
  
  

#DX9S_SCREEN_TRIPLEBUFFERING=1
#DX9S_SCREEN_QUADRUPLEBUFFERING=2
#DX9S_SCREEN_DISABLEVSYNC=4
#DX9S_SCREEN_ZBUFFER=8
#DX9S_SCREEN_STENCILBUFFER=16
#DX9S_SCREEN_LOCKABLE=32  

; The default flags for DX9S_SetCreationFlags() are
; #DX9S_SCREEN_LOCKABLE|#DX9S_SCREEN_DISABLEVSYNC.
; Note: You should always use #DX9S_SCREEN_LOCKABLE if you want to use ScreenOutput().
; This cmmand must be called before OpenScreen() or OpenWindowedScreen().
Procedure DX9S_SetCreationFlags(Flags.l)
  !EXTRN _PB_DX9S_Screen_CreationFlags
  !MOV Eax,[Esp+4]
  !MOV [_PB_DX9S_Screen_CreationFlags],Eax
EndProcedure
  

#TexRes_Type=0
#TexRes_Width=4
#TexRes_Height=8
#TexRes_Depth=12
#TexRes_CreateTexture=16
#TexRes_GetUpdatedTexture=20
#TexRes_SetTransColor=24
#TexRes_Lock=28
#TexRes_UnLock=32
#TexRes_GetDC=36
#TexRes_ReleaseDC=40
#TexRes_GetRTSurface=44
#TexRes_OnLost=48
#TexRes_Restore=52
#TexRes_Free=56
#TexRes_Optimize=60

Structure TexRes
  VTable.l
  Type.l ; #TEXRES_DYNAMIC_A1R5G5B5,#TEXRES_STATIC_A1R5G5B5 or #TEXRES_STATIC_A8R8G8B8
  Width.l
  Height.l
  IsDynamic.l
  CanMakeDynamic.l ; needed to optimize the TexRes
  RealTexture.l ; true if created with #PB_Sprite_Texture
  TransparentColor.l
  LockSinceGetRTSurface.l
  RTToSysMemCopyNeeded.l
  TextureUpdateNeeded.l
  DC.l
  QuickGetDCMethod.l
  Locked.l
  NumLocks.l ; needed to optimize the TexRes
  D3DDevice.l
  SysmemSurface.l
  Texture.l
  TextureSurface.l
  RTSurface.l
EndStructure

Procedure DX9S_GetSpriteDC(Sprite)
  SpriteID=SpriteID(Sprite)
  VTable=PeekL(SpriteID)
  ProcedureReturn CallFunctionFast(PeekL(VTable+#TexRes_GetDC),SpriteID)
EndProcedure

Procedure DX9S_ReleaseSpriteDC(Sprite)
  SpriteID=SpriteID(Sprite)
  VTable=PeekL(SpriteID)
  ProcedureReturn CallFunctionFast(PeekL(VTable+#TexRes_ReleaseDC),SpriteID,0)
EndProcedure  

Procedure DX9S_GetSpriteTexture(Sprite)
  SpriteID=SpriteID(Sprite)
  VTable=PeekL(SpriteID)
  ProcedureReturn CallFunctionFast(PeekL(VTable+#TexRes_GetUpdatedTexture),SpriteID)
EndProcedure



Interface nIAMMultiMediaStream
  QueryInterface(a, b)
  AddRef()
  Release()
  GetInformation(a, b)
  GetMediaStream(a, b)
  EnumMediaStreams(a, b)
  GetState(a)
  SetState(a)
  GetTime(a)
  GetDuration(a)
  Seek(a, b)
  GetEndOfStreamEventHandle(a)
  Initialize(a, b, c)
  GetFilterGraph(a)
  GetFilter(a)
  AddMediaStream(a, b,c,d)
  OpenFile(a.p-bstr, b)
  OpenMoniker(a, b, c)
  Render(a)
EndInterface


DataSection
CLSID_AMMultiMediaStream:
Data.l $49C47CE5
Data.w $9BA4,$11D0
Data.b $82,$12,$0,$C0,$4F,$C3,$2C,$45

IID_IAMMultiMediaStream:
Data.l $BEBE595C
Data.w $9A6F,$11D0
Data.b $8F,$DE,$0,$C0,$4F,$D9,$18,$9D

MSPID_PrimaryVideo:
Data.l $A35FF56A
Data.w $9FDA,$11D0
Data.b $8F,$DF,$0,$C0,$4F,$D9,$18,$9D   

IID_IDirectDrawMediaStream:
Data.l $F4104FCE
Data.w $9A70,$11D0
Data.b $8F,$DE,$0,$C0,$4F,$D9,$18,$9D
EndDataSection

#AMMSF_NOCLOCK = 4

Structure DX9S_Video
  MultiMediaStream.nIAMMultiMediaStream
  MediaStream.IMediaStream
  DDStream.IDirectDrawMediaStream
  Sample.IDirectDrawStreamSample
  DDS.IDirectDrawSurface
EndStructure

Procedure DX9S_LoadVideo(File.s)
  Result.l=CoInitialize_(0)
  
  If Result=#S_OK Or Result=#S_FALSE
    
    CoCreateInstance_(?CLSID_AMMultiMediaStream,0,1,?IID_IAMMultiMediaStream,@*MultiMediaStream.nIAMMultiMediaStream) 
    If *MultiMediaStream
      
      *MultiMediaStream\Initialize(0,0,0)
      *MultiMediaStream\AddMediaStream(0,?MSPID_PrimaryVideo,0,0) 
      If *MultiMediaStream\OpenFile(File,#AMMSF_NOCLOCK)=#S_OK
        
        *MultiMediaStream\GetMediaStream(?MSPID_PrimaryVideo,@*MediaStream.IMediaStream)
        If *MediaStream
          *MediaStream\QueryInterface(?IID_IDirectDrawMediaStream,@*DDStream.IDirectDrawMediaStream)
          If *DDStream
            
            *DDStream\CreateSample(0,0,0,@*Sample.IDirectDrawStreamSample)
            If *Sample
              
              *Sample\GetSurface(@*DDS.IDirectDrawSurface,0)
              If *DDS
                
                *Video.DX9S_Video=AllocateMemory(SizeOf(DX9S_Video))
                
                If *Video
                  
                  *MultiMediaStream\SetState(1) 
                  *Video\MultiMediaStream=*MultiMediaStream
                  *Video\MediaStream=*MediaStream
                  *Video\DDStream=*DDStream
                  *Video\Sample=*Sample
                  *Video\DDS=*DDS
                  
                  ProcedureReturn *Video
                EndIf
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
    
    If *DDS
      *DDS\Release()
    EndIf
    
    If *Sample
      *Sample\Release()
    EndIf
    
    If *DDStream
      *DDStream\Release()
    EndIf
    
    If *MediaStream
      *MediaStream\Release()
    EndIf
    
    If *MultiMediaStream
      *MultiMediaStream\Release()
    EndIf
    
    CoUninitialize_()
  EndIf
  
EndProcedure


  
Procedure DX9S_RenderVideoToSprite(*Video.DX9S_Video,Sprite)
  If *Video=0:ProcedureReturn #False:EndIf
  SpriteID=SpriteID(Sprite)
  DestDC=DX9S_GetSpriteDC(Sprite)
  *Video\DDS\GetDC(@SrcDC)
  VTable=PeekL(SpriteID)
  Width=CallFunctionFast(PeekL(VTable+#TexRes_Width),SpriteID)
  Height=CallFunctionFast(PeekL(VTable+#TexRes_Height),SpriteID)
  Result=BitBlt_(DestDC,0,0,Width,Height,SrcDC,0,0,#SRCCOPY)
  *Video\DDS\ReleaseDC(SrcDC)
  DX9S_ReleaseSpriteDC(Sprite)
  ProcedureReturn Result
EndProcedure
  
Procedure DX9S_NextVideoFrame(*Video.DX9S_Video)
  If *Video=0:ProcedureReturn #False:EndIf
  *Video\Sample\Update(0,0,0,0) 
EndProcedure  
  
Procedure DX9S_FreeVideo(*Video.DX9S_Video)
  If *Video=0:ProcedureReturn #False:EndIf
  If *Video\DDS
    *Video\DDS\Release()
  EndIf
  If *Video\Sample
    *Video\Sample\Release()
  EndIf
  If *Video\DDStream
    *Video\DDStream\Release()
  EndIf
  If *Video\MediaStream
    *Video\MediaStream\Release()
  EndIf
  If *Video\MultiMediaStream
    *Video\MultiMediaStream\Release()
  EndIf
  CoUninitialize_()
EndProcedure  

Procedure DX9S_SetSecureMode(Mode) ; #True / #False (default)
!EXTRN _PB_DX9S_SecureMode
!MOV EAX,[Esp+4]
!MOV [_PB_DX9S_SecureMode],Eax
EndProcedure

Procedure DX9S_IsPixelShaderUsed()
!EXTRN _PB_DX9S_PixelShader14Used
!MOV Eax,[_PB_DX9S_PixelShader14Used]
ProcedureReturn
EndProcedure

Procedure DX9S_BeginScene() ; should be used instead of *D3DDevice\BeginScene() 
!EXTRN _PB_DX9S_BeginScene
*D3DDevice.IDirect3DDevice9=DX9S_GetD3DDevice9()
If *D3DDevice\BeginScene()=#S_OK
!MOV [_PB_DX9S_BeginScene],1
ProcedureReturn #True
EndIf
EndProcedure

Procedure DX9S_EndScene() ; should be used instead of *D3DDevice\EndScene() 
!EXTRN _PB_DX9S_BeginScene
*D3DDevice.IDirect3DDevice9=DX9S_GetD3DDevice9()
If *D3DDevice\EndScene()=#S_OK
!MOV [_PB_DX9S_BeginScene],0
ProcedureReturn #True
EndIf
EndProcedure


;Complete List:
;_PB_D3DBase
;_PB_DX9S_Direct3D_Device
;_PB_DX9S_Screen_AutoStretch
;_PB_DX9S_Screen_Depth
;_PB_DX9S_Screen_Height
;_PB_DX9S_Screen_RealHeight
;_PB_DX9S_Screen_RealWidth
;_PB_DX9S_Screen_Width
;_PB_DX9S_Screen_Windowed
;_PB_DX9S_Screen_WindowedBottomBorder
;_PB_DX9S_Screen_WindowedRightBorder
;_PB_DX9S_Screen_WindowedXOffset
;_PB_DX9S_Screen_WindowedYOffset
;_PB_DX9S_Screen_CreationFlags
;_PB_DX9S_PixelShader14Used
;_PB_DX9S_BeginScene
;_PB_DX9S_S3DQuality
;_PB_DX9S_d3dpp
;_PB_DX9S_d3dcaps
;_PB_DX9S_IsScreenActive
;_PB_DX9S_Screen_Target
;_PB_DX9S_SecureMode
;_PB_DX9S_DIJ8_State
;_PB_DX9S_DS8_DS
;_PB_DX9S_DIM8_State
;_PB_DX9S_DIK8_Device

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 147
; FirstLine = 147
; Folding = -----
; SubSystem = DX9
; DisableDebugger