IncludeFile "DX9SEx.pbi"

#D3DADAPTER_DEFAULT=0 
#D3DDEVTYPE_HAL=1
#D3DSWAPEFFECT_DISCARD=1
#D3DFMT_UNKNOWN=0  
#D3DFMT_D16=80

#D3DCREATE_SOFTWARE_VERTEXPROCESSING=32 
#D3DCLEAR_TARGET=1 
#D3DCLEAR_ZBUFFER=2

#D3DTS_WORLD=256
#D3DTS_VIEW=2
#D3DTS_PROJECTION=3

#D3DRS_LIGHTING=137
#D3DTSS_TEXCOORDINDEX=11

Structure D3DXMATRIX 
  _11.f 
  _12.f 
  _13.f 
  _14.f 
  _21.f 
  _22.f 
  _23.f 
  _24.f 
  _31.f 
  _32.f 
  _33.f 
  _34.f 
  _41.f 
  _42.f 
  _43.f 
  _44.f 
EndStructure


Global D3DX9

Procedure D3DX9_MakeTextMesh(FontID.l,Text.s)
  MemDC=CreateCompatibleDC_(0)
  SelectObject_(MemDC,FontID)
  CallFunction(D3DX9,"D3DXCreateTextA",DX9S_GetD3DDevice9(),MemDC,Text.s,1.0,0.25,@*Mesh.ID3DXMesh,0,0)
  DeleteDC_(MemDC)
  CallFunction(D3DX9,"D3DXComputeNormals",*Mesh,0)
  ProcedureReturn *Mesh
EndProcedure

Procedure D3DX9_DrawMesh(*Mesh.ID3DXMesh,Sprite,x.f,y.f,z.f,angleX.f,angleY.f,angleZ.f)
  CallFunction(D3DX9,"D3DXMatrixTranslation",Translate.D3DXMATRIX,x,y,z)
  CallFunction(D3DX9,"D3DXMatrixRotationX",RotX.D3DXMATRIX,angleX)
  CallFunction(D3DX9,"D3DXMatrixRotationY",RotY.D3DXMATRIX,angleY)
  CallFunction(D3DX9,"D3DXMatrixRotationZ",RotZ.D3DXMATRIX,angleZ)
  
  CallFunction(D3DX9,"D3DXMatrixMultiply",World.D3DXMATRIX,RotX,RotY)
  CallFunction(D3DX9,"D3DXMatrixMultiply",World.D3DXMATRIX,World,RotZ)
  CallFunction(D3DX9,"D3DXMatrixMultiply",World.D3DXMATRIX,World,Translate)
  
  *D3DDevice.IDirect3DDevice9=DX9S_GetD3DDevice9()
  *D3DDevice\SetTransform(#D3DTS_WORLD,World) 
  *D3DDevice\SetTexture(0,DX9S_GetSpriteTexture(Sprite))
  *Mesh\DrawSubset(0)
EndProcedure




D3DX9=OpenLibrary(#PB_Any,"d3dx9_24.dll")

If D3DX9=0
  MessageRequester("ERROR","Can't load d3dx9_24.dll.")
  End
EndIf

; We need a ZBuffer for this application...
DX9S_SetCreationFlags(#DX9S_SCREEN_ZBUFFER|#DX9S_SCREEN_LOCKABLE)

InitSprite()
InitSprite3D()

OpenWindow(1,0,0,640,480,"D3DXMesh sample",#PB_Window_ScreenCentered|#PB_Window_SystemMenu|#PB_Window_Minimize)
OpenWindowedScreen(WindowID(1),0,0,640,480,1,0,0)

LoadSprite(1,"Lights.bmp",#PB_Sprite_Texture)

*D3DDevice.IDirect3DDevice9=DX9S_GetD3DDevice9()

LoadFont(1,"Arial",20)
*Mesh=D3DX9_MakeTextMesh(FontID(1),"DX9 Subsystem")

CallFunction(D3DX9,"D3DXMatrixPerspectiveLH",Proj.D3DXMATRIX,1.0,3/4.0,1.0,100.0)
; set projection matrix
*D3DDevice\SetTransform(#D3DTS_PROJECTION,Proj)

*D3DDevice\SetRenderState(#D3DRS_LIGHTING,#False) ; disable lighting

*D3DDevice\SetTextureStageState(0,#D3DTSS_TEXCOORDINDEX,$40000)

Repeat
  
  ClearScreen(#Blue)
  ; For now we have to clear the ZBuffer on our own.
  *D3DDevice\Clear(0,0,#D3DCLEAR_ZBUFFER,0,1.0,0)
  
  x.f+0.01
  DX9S_BeginScene() ; (note: DX9S_EndScene() is not needed... )
  D3DX9_DrawMesh(*Mesh,1,-3,0,7,x,0,0)

  StartDrawing(ScreenOutput())
  DrawText(0,0,"Test...")
  StopDrawing()
  
  FlipBuffers(1)
  
  
Until WindowEvent()=#PB_Event_CloseWindow
; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 97
; FirstLine = 74
; Folding = -
; SubSystem = DX9